varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;

uniform sampler2D u_texture;
uniform float  u_time;
	
uniform vec4  u_threshold;

void main()
{	
	//get base texture color
	vec4 baseColor = texture2D(u_texture, v_texCoord);
	
	float gray = (baseColor.r+baseColor.g+baseColor.b)/3.0;
	
	
        float intensity = smoothstep( gray-0.1, gray, u_threshold.x) - 
			  smoothstep( gray, gray+0.1, u_threshold.x);

	gl_FragColor.rgb = baseColor.rgb+intensity*0.5;
	gl_FragColor.a = baseColor.a;
}
