varying lowp vec2 v_texCoord;
varying highp vec4 v_color;

uniform highp float u_time;
	
uniform sampler2D u_texture;
uniform sampler2D u_texture1;
	
uniform vec4 u_interval; //pos u, pov, size u, size v
uniform vec4 u_displacement;// base speed u, base speed v, gradient speed u
uniform vec4 u_multiplier;

void main()
{
	vec2 uv = v_texCoord;

	//***** uncomment this to animate in F.E.*****
	//vec4 displacement = u_displacement * u_time;
	//***********

	vec4 displacement = u_displacement;
	
	//Interval
	vec2 intervalPos;
	intervalPos.x = u_interval.x + displacement.z;
	intervalPos.y = u_interval.y + displacement.w;

	vec2 intervalSize;
	intervalSize.x = u_interval.z;
	intervalSize.y = u_interval.w;
	
	vec2 displacementUV;
	displacementUV.x = intervalPos.x + (uv.x * intervalSize.x) + displacement.x;
	displacementUV.y = intervalPos.y + (uv.y * intervalSize.y) + displacement.y;
	
	vec4 distortion = texture2D(u_texture1, displacementUV);
	float distortionU = (distortion.r - 0.5) * u_multiplier.x;
	float distortionV = (distortion.g - 0.5) * u_multiplier.y;
	
	float intensity = texture2D(u_texture1, uv).b;
	vec2 textCoordDistortion = vec2(distortionU, distortionV) * intensity;	
	vec4 texColor = texture2D(u_texture, uv + textCoordDistortion);

	gl_FragColor = texColor * v_color;
}