varying highp vec2 v_texCoord;
varying highp vec4 v_color;

uniform sampler2D u_texture;
uniform sampler2D u_texture1;
uniform sampler2D u_texture2;
uniform float  u_time;

uniform vec4 u_scale_y_position;
	
uniform vec4 u_interval;
uniform vec4 u_displacement;
uniform vec4 u_multiplier;

	
void main()
{
	//mask
	vec2 scale = u_scale_y_position.xy;
	float yPosition = u_scale_y_position.z;
	vec2 maskPosition = v_texCoord;
	maskPosition.y -= yPosition;
	vec2 maskTexCoord = maskPosition / scale;
	vec4 maskColor = texture2D(u_texture1, maskTexCoord);
	
	//***** uncomment this to animate in F.E.*****
	//vec4 displacement = u_displacement * u_time;
	//***********
	
	//displacement
	vec4 displacement = u_displacement;
	//Interval
	vec2 intervalPos;
	intervalPos.x = u_interval.x + displacement.z;
	intervalPos.y = u_interval.y + displacement.w;
	vec2 intervalSize;
	intervalSize.x = u_interval.z;
	intervalSize.y = u_interval.w;
	
	vec2 displacementUV;
	displacementUV.x = intervalPos.x + (v_texCoord.x * intervalSize.x) + displacement.x;
	displacementUV.y = intervalPos.y + (v_texCoord.y * intervalSize.y) + displacement.y;

	vec4 displacementColor = texture2D(u_texture2, displacementUV);
	lowp float gsDisplacementColorX = ((displacementColor.r * u_multiplier.x) - (u_multiplier.x*0.5));
	lowp float gsDisplacementColorY = ((displacementColor.r * u_multiplier.y) - (u_multiplier.y*0.5));

	vec2 uvBase;
	uvBase.x = v_texCoord.x + gsDisplacementColorX;
	uvBase.y = v_texCoord.y + gsDisplacementColorY;
	
	vec4 textureColor = texture2D(u_texture, uvBase);
	
	gl_FragColor.rgb =  textureColor.rgb * maskColor.g * v_color.rgb;
	gl_FragColor.a =  v_color.a * abs(u_scale_y_position.w - maskColor.r) * textureColor.a;
}


