varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;

uniform sampler2D u_texture;
uniform sampler2D u_texture1;
uniform float  u_time;
	
uniform vec4  u_threshold;
uniform vec4  u_fireColor;

void main()
{	
	//get base texture color
	vec4 baseColor = texture2D(u_texture, v_texCoord);
	
	//sample noise texture
	vec4 noiseColor = texture2D(u_texture1, v_texCoord*2.0);
	float e = 0.0001;
	float delta = clamp((noiseColor.x-u_threshold.x)/(u_threshold.x+e),0.0,1.0);
	
	gl_FragColor.rgb = mix(u_fireColor.rgb,baseColor.rgb,delta);
	gl_FragColor.a = baseColor.a * step(u_threshold.x,noiseColor.x);
}
